require "prct06/version"
#create a Struct with :value and :next
Node = Struct.new(:value, :next, :before)
class List
	include Enumerable
	include Comparable
	attr_accessor :cabeza
	attr_accessor :cola
	def initialize(inicio=nil)
		@cola = @cabeza = Node.new(inicio) if inicio
	end

	def add(value)
		node = Node.new(value)
		node.next = @cabeza
		@cabeza.before = node

		@cabeza = node
	end
	
	def add_from_tail(value)
		node = Node.new(value)
		node.before = @cola
		@cola.next = node
		
		@cola = node
	end
	
	def remove
		@cabeza = @cabeza.next
	end

	def remove_from_tail
		@cola = @cola.before
		@cola.next = nil
	end
	def to_s
		while @cabeza != nil do
			puts @cabeza.value
			remove()
		end
	end
	def each
		aux = @cabeza
		while aux != nil do
			yield aux.value
			aux = aux.next
		end
	end
end
