require "prct06/version"
class Diet  
	#Declaración de los métodos de escritura
	#y lectura para todas las variable de la clase
	include Comparable
	attr_accessor :ttl #Título
	attr_accessor :tag #Etiqueta
	attr_accessor :dip #Ingesta Diaria
	attr_accessor :vct #Valor calorífico Total
	attr_accessor :rcps #Array de platos
	attr_accessor :pprtn #Porcentaje de proteínas
	attr_accessor :pfts #Porcentaje de grasas
	attr_accessor :pchdt #Porcentaje de hidratos de carbono       
         def initialize(tag, &block)
		self.tag = tag
       		 @rcps  = Array.new #Array de platos
		instance_eval &block
        end
	#Con este método añadimos en el array un nuevo plato
	#siguiendo el formato predefinido.
	def new_recipe(dstn,ptn,dig)
		tmp = "- #{dstn}, #{ptn} unidades, #{dig} g\n"
		rcps << tmp
	end
	
	def <=> otra_dieta
		self.vct <=> otra_dieta.vct
	end

	def to_s
		mostrar = ""
		 mostrar << "\n\n#{@ttl} (#{@dip} %)\n"
 		 for i in 0..(@rcps.length-1)
  			 mostrar << "- #{@rcps[i]}\n"
  		end
  		mostrar << "V.C.T | % #{@vct} kcal | #{@pprtn}% - #{@pfts}% - #{@pchdt}%\n\n"
	end
	def titulo (name)
		@ttl=name
	end
	def ingesta (options = {})
		@dip="(#{options[:min]},#{options[:max]})"
	end
	def plato (options = {})
		rcps << "(#{options[:descripcion]})"
		rcps << "(#{options[:porcion]})"
		rcps << "(#{options[:gramos]})"
	end
	def porcentajes (options = {})
		@vct="(#{options[:vct]})"
		@pprtn="(#{options[:proteinas]})"
		@pfts="(#{options[:grasas]})"
		@pchdt="(#{options[:hidratos]})"
	end
	
end
